# -*- coding: UTF-8 -*-

import re

from resources.lib.modules import client
from resources.lib.modules import client_utils
from resources.lib.modules import cleantitle
from resources.lib.modules import scrape_sources
from resources.lib.modules import log_utils


class source:
    def __init__(self):
        self.results = []
        self.domains = ['putlockers.net']
        self.base_link = 'https://wwv.putlockers.net'
        self.search_link = '/search/?s=%s'


    def movie(self, imdb, title, localtitle, aliases, year):
        try:
            search_url = self.base_link + self.search_link % cleantitle.get_plus(title)
            r = client.request(search_url)
            r = client_utils.parseDOM(r, 'div', attrs={'class': 'featuredItems singleVideo'})
            r = [(client_utils.parseDOM(i, 'a', ret='href'), client_utils.parseDOM(i, 'a', ret='oldtitle'), client_utils.parseDOM(i, 'div', attrs={'class': 'jt-info'})) for i in r]
            r = [(i[0][0], i[1][0], i[2][0]) for i in r if len(i[0]) > 0 and len(i[1]) > 0 and len(i[2]) > 0]
            link = [i[0] for i in r if cleantitle.match_alias(i[1], aliases) and cleantitle.match_year(i[2], year)][0]
            page = client.request(link)
            videoArea = client_utils.parseDOM(page, 'div', attrs={'class': 'videoArea'})
            url = client_utils.parseDOM(videoArea, 'a', ret='href')[0]
            return url
        except Exception:
            log_utils.log('movie', 1)
            return


    def tvshow(self, imdb, tvdb, tvshowtitle, localtvshowtitle, aliases, year):
        try:
            search_url = self.base_link + self.search_link % cleantitle.get_plus(tvshowtitle)
            r = client.request(search_url)
            r = client_utils.parseDOM(r, 'div', attrs={'class': 'featuredItems singleVideo'})
            r = [(client_utils.parseDOM(i, 'a', ret='href'), client_utils.parseDOM(i, 'a', ret='oldtitle'), client_utils.parseDOM(i, 'div', attrs={'class': 'jt-info'})) for i in r]
            r = [(i[0][0], i[1][0], i[2][0]) for i in r if len(i[0]) > 0 and len(i[1]) > 0 and len(i[2]) > 0]
            link = [i[0] for i in r if cleantitle.match_alias(i[1], aliases) and cleantitle.match_year(i[2], year) and '/series/' in i[0]][0]
            url = re.findall('(?://.+?|)(/.+)', link)[0]
            return url
        except Exception:
            log_utils.log('tvshow', 1)
            return


    def episode(self, url, imdb, tvdb, title, premiered, season, episode):
        try:
            if not url:
                return
            tvshowtitle = re.findall('/series/(.+?)/', url)[0]
            link = self.base_link + '/episode/%s-%sx%s/' % (tvshowtitle, season, episode)
            episodePage = client.request(link)
            videoArea = client_utils.parseDOM(episodePage, 'div', attrs={'class': 'videoArea'})
            url = client_utils.parseDOM(videoArea, 'a', ret='href')[0]
            return url
        except Exception:
            log_utils.log('episode', 1)
            return


    def sources(self, url, hostDict):
        try:
            if url == None:
                return self.results
            html = client.request(url)
            links = client_utils.parseDOM(html, 'iframe', ret='src')
            for link in links:
                for source in scrape_sources.process(hostDict, link):
                    self.results.append(source)
            return self.results
        except Exception:
            log_utils.log('sources', 1)
            return self.results


    def resolve(self, url):
        return url


