# -*- coding: UTF-8 -*-

import re

from six.moves.urllib_parse import parse_qs, urlencode

from resources.lib.modules import client
from resources.lib.modules import client_utils
from resources.lib.modules import cleantitle
#from resources.lib.modules import log_utils
from resources.lib.modules import scrape_sources


class source:
    def __init__(self):
        self.results = []
        self.domains = ['movie4u.live', 'movies4u.co']
        self.base_link = 'https://www1.movie4u.live'


    def movie(self, imdb, title, localtitle, aliases, year):
        try:
            url = {'imdb': imdb, 'title': title, 'year': year}
            url = urlencode(url)
            return url
        except:
            #log_utils.log('movie', 1)
            return


    def tvshow(self, imdb, tvdb, tvshowtitle, localtvshowtitle, aliases, year):
        try:
            url = {'imdb': imdb, 'tvdb': tvdb, 'tvshowtitle': tvshowtitle, 'year': year}
            url = urlencode(url)
            return url
        except:
            #log_utils.log('tvshow', 1)
            return


    def episode(self, url, imdb, tvdb, title, premiered, season, episode):
        try:
            if not url:
                return
            url = parse_qs(url)
            url = dict([(i, url[i][0]) if url[i] else (i, '') for i in url])
            url['title'], url['premiered'], url['season'], url['episode'] = title, premiered, season, episode
            url = urlencode(url)
            return url
        except:
            #log_utils.log('episode', 1)
            return


    def sources(self, url, hostDict):
        try:
            if url == None:
                return self.results
            data = parse_qs(url)
            data = dict([(i, data[i][0]) if data[i] else (i, '') for i in data])
            title = data['tvshowtitle'] if 'tvshowtitle' in data else data['title']
            season, episode = (data['season'], data['episode']) if 'tvshowtitle' in data else ('0', '0')
            year = data['premiered'].split('-')[0] if 'tvshowtitle' in data else data['year']
            search_title = cleantitle.geturl(title)
            if 'tvshowtitle' in data:
                search_url = self.base_link + '/episodes/%s-%sx%s/' % (search_title, season, episode)
            else:
                search_url = self.base_link + '/movies/%s' % search_title
            item_url = client.request(search_url, timeout='10', output='geturl')
            ## Note: check to see if this geturl bit is still needed.
            item_html = client.request(item_url)
            
            item_date = client_utils.parseDOM(item_html, 'span', attrs={'class': 'date'})[0]
            if not (year in item_date or data['year'] in item_date):
                return self.results
            item_holder = client_utils.parseDOM(item_html, 'div', attrs={'class':'bwa-content'})[0]
            item_holder = client_utils.parseDOM(item_holder, 'a', ret='href')[0]
            page_html = client.request(item_holder)
            page_links = client_utils.parseDOM(page_html, 'iframe', ret='src', attrs={'class': 'metaframe rptss'})
            for link in page_links:
                #log_utils.log('link: ' + repr(link))
                try:
                    link = url = client.request(link, timeout='10', output='geturl') if 'player.php' in link else link
                    for source in scrape_sources.process(hostDict, link):
                        self.results.append(source)
                except:
                    #log_utils.log('sources', 1)
                    pass
            return self.results
        except:
            #log_utils.log('sources', 1)
            return self.results


    def resolve(self, url):
        return url


