# -*- coding: UTF-8 -*-

import re

from six.moves.urllib_parse import parse_qs, urlencode

from resources.lib.modules import client
from resources.lib.modules import client_utils
from resources.lib.modules import cleantitle
from resources.lib.modules import scrape_sources
#from resources.lib.modules import log_utils


class source:
    def __init__(self):
        try:
            self.results = []
            self.domains = ['yesmovies.lat', 'yesmovies.gg']
            self.base_link = 'https://yesmovies.lat'
        except Exception:
            #log_utils.log('__init__', 1)
            return


    def movie(self, imdb, title, localtitle, aliases, year):
        try:
            url = {'imdb': imdb, 'title': title, 'year': year}
            url = urlencode(url)
            return url
        except Exception:
            #log_utils.log('movie', 1)
            return


    def tvshow(self, imdb, tvdb, tvshowtitle, localtvshowtitle, aliases, year):
        try:
            url = {'imdb': imdb, 'tvshowtitle': tvshowtitle, 'year': year}
            url = urlencode(url)
            return url
        except Exception:
            #log_utils.log('tvshow', 1)
            return


    def episode(self, url, imdb, tvdb, title, premiered, season, episode):
        try:
            if url is None:
                return
            url = parse_qs(url)
            url = dict([(i, url[i][0]) if url[i] else (i, '') for i in url])
            url['title'], url['premiered'], url['season'], url['episode'] = title, premiered, season, episode
            url = urlencode(url)
            return url
        except Exception:
            #log_utils.log('episode', 1)
            return


    def sources(self, url, hostDict):
        try:
            if url == None:
                return self.results
            data = parse_qs(url)
            data = dict([(i, data[i][0]) if data[i] else (i, '') for i in data])
            title = data['tvshowtitle'] if 'tvshowtitle' in data else data['title']
            year = data['premiered'].split('-')[0] if 'tvshowtitle' in data else data['year']
            search_title = cleantitle.geturl(title)
            try:
                if 'tvshowtitle' in data:
                    search_link = self.base_link + '/film/%s-season-%s/watching.html?ep=%s' % (search_title, data['season'], data['episode'])
                else:
                    search_link = self.base_link + '/film/%s-%s/watching.html?ep=0' % (search_title, year)
                html = client.scrapePage(search_link).text
                check_year = re.findall('Release:.+?(\d{4})', html)[0]
                check_year = cleantitle.match_year(check_year, year, data['year'])
                if not check_year:
                    raise Exception
            except:
                if 'tvshowtitle' in data:
                    search_link = self.base_link + '/film/%s-season-%s/watching.html?ep=%s' % (search_title, data['season'], data['episode'])
                else:
                    search_link = self.base_link + '/film/%s/watching.html?ep=0' % search_title
                html = client.scrapePage(search_link).text
                check_year = re.findall('Release:.+?(\d{4})', html)[0]
                check_year = cleantitle.match_year(check_year, year, data['year'])
                if not check_year:
                    raise Exception
            try:
                qual = client_utils.parseDOM(html, 'span', attrs={'class': 'quality'})[0]
            except:
                qual = 'SD'
            links = client_utils.parseDOM(html, 'li', ret='data-video')
            for link in links:
                for source in scrape_sources.process(hostDict, link, info=qual):
                    self.results.append(source)
            return self.results
        except Exception:
            #log_utils.log('sources', 1)
            return self.results


    def resolve(self, url):
        return url


